/* Generated from Extensions for empathy



 */

#ifdef __cplusplus
extern "C" {
#endif

/**
 *
EmpTubeChannelState:
 * @EMP_TUBE_CHANNEL_STATE_LOCAL_PENDING: <![CDATA[           The initiator offered the tube. The tube is waiting to be           accepted/closed locally. If the client accepts the tube, the tube's           state will be Open.         ]]>
 * @EMP_TUBE_CHANNEL_STATE_REMOTE_PENDING: <![CDATA[           The tube is waiting to be accepted/closed remotely. If the           recipient accepts the tube, the tube's state will be Open.         ]]>
 * @EMP_TUBE_CHANNEL_STATE_OPEN: <![CDATA[           The initiator offered the tube and the recipient accepted it. The           tube is open for traffic. The tube's state stays in this state until           it is closed.         ]]>
 * @EMP_TUBE_CHANNEL_STATE_NOT_OFFERED: <![CDATA[           The tube channel has been requested but the tube is not yet offered.           The client should offer the tube to the recipient and the tube's           state will be Remote_Pending. The method to offer the tube depend on           the tube type.         ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    EMP_TUBE_CHANNEL_STATE_LOCAL_PENDING = 0,
    EMP_TUBE_CHANNEL_STATE_REMOTE_PENDING = 1,
    EMP_TUBE_CHANNEL_STATE_OPEN = 2,
    EMP_TUBE_CHANNEL_STATE_NOT_OFFERED = 3,
} EmpTubeChannelState;

/**
 * NUM_EMP_TUBE_CHANNEL_STATES:
 *
 * 1 higher than the highest valid value of #EmpTubeChannelState.
 */
#define NUM_EMP_TUBE_CHANNEL_STATES (3+1)

/**
 *
EmpLocationAccuracyLevel:
 * @EMP_LOCATION_ACCURACY_LEVEL_NONE: <![CDATA[           The accuracy is unspecified.         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_COUNTRY: <![CDATA[           The location indicates the contact's country.         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_REGION: <![CDATA[           The location indicates the contact's region within a country.         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_LOCALITY: <![CDATA[           The location indicates the contact's locality within a region           (e.g. the correct city).         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_POSTAL_CODE: <![CDATA[           The location indicates the correct postal code.         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_STREET: <![CDATA[           The location indicates the correct street.         ]]>
 * @EMP_LOCATION_ACCURACY_LEVEL_DETAILED: <![CDATA[           The location's accuracy is given by the error, horizontal-error-m           and/or vertical-error-m keys.         ]]>
 *
 * <![CDATA[         A location accuracy level. This should be kept in sync with         GeoclueAccuracyLevel in the Geoclue project.       ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    EMP_LOCATION_ACCURACY_LEVEL_NONE = 0,
    EMP_LOCATION_ACCURACY_LEVEL_COUNTRY = 1,
    EMP_LOCATION_ACCURACY_LEVEL_REGION = 2,
    EMP_LOCATION_ACCURACY_LEVEL_LOCALITY = 3,
    EMP_LOCATION_ACCURACY_LEVEL_POSTAL_CODE = 4,
    EMP_LOCATION_ACCURACY_LEVEL_STREET = 5,
    EMP_LOCATION_ACCURACY_LEVEL_DETAILED = 6,
} EmpLocationAccuracyLevel;

/**
 * NUM_EMP_LOCATION_ACCURACY_LEVELS:
 *
 * 1 higher than the highest valid value of #EmpLocationAccuracyLevel.
 */
#define NUM_EMP_LOCATION_ACCURACY_LEVELS (6+1)


#ifdef __cplusplus
}
#endif
