#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _emp_svc_channel_handler_object_info;

struct _EmpSvcChannelHandlerClass {
    GTypeInterface parent_class;
    emp_svc_channel_handler_handle_channel_impl handle_channel;
};

static void emp_svc_channel_handler_base_init (gpointer klass);

GType
emp_svc_channel_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelHandlerClass),
        emp_svc_channel_handler_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelHandler", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_handler_handle_channel_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel_Type: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * HandleChannel on interface org.freedesktop.Telepathy.ChannelHandler.
 */
static void
emp_svc_channel_handler_handle_channel (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_handler_handle_channel_impl impl = (EMP_SVC_CHANNEL_HANDLER_GET_CLASS (self)->handle_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel_Type,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_handler_implement_handle_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HandleChannel D-Bus method
 *
 * Register an implementation for the HandleChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl)
{
  klass->handle_channel = impl;
}

static inline void
emp_svc_channel_handler_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.ChannelHandler");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_HANDLER, &interface);

  dbus_g_object_type_install_info (emp_svc_channel_handler_get_type (),
      &_emp_svc_channel_handler_object_info);
}
static void
emp_svc_channel_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_handler_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_handler_methods[] = {
  { (GCallback) emp_svc_channel_handler_handle_channel, _emp_ext_marshal_VOID__STRING_BOXED_STRING_BOXED_UINT_UINT_POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_channel_handler_object_info = {
  0,
  _emp_svc_channel_handler_methods,
  1,
"org.freedesktop.Telepathy.ChannelHandler\0HandleChannel\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel_Type\0I\0s\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_channel_interface_tube_object_info;

struct _EmpSvcChannelInterfaceTubeClass {
    GTypeInterface parent_class;
};

enum {
    SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged,
    N_CHANNEL_INTERFACE_TUBE_SIGNALS
};
static guint channel_interface_tube_signals[N_CHANNEL_INTERFACE_TUBE_SIGNALS] = {0};

static void emp_svc_channel_interface_tube_base_init (gpointer klass);

GType
emp_svc_channel_interface_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelInterfaceTubeClass),
        emp_svc_channel_interface_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelInterfaceTube", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_interface_tube_emit_tube_channel_state_changed:
 * @instance: The object implementing this interface
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * TubeChannelStateChanged signal on interface org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT.
 */
void
emp_svc_channel_interface_tube_emit_tube_channel_state_changed (gpointer instance,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE));
  g_signal_emit (instance,
      channel_interface_tube_signals[SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged],
      0,
      arg_state);
}

static inline void
emp_svc_channel_interface_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{sv}", 0, NULL, NULL }, /* Parameters */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* State */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT");
  properties[0].name = g_quark_from_static_string ("Parameters");
  properties[0].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE));
  properties[1].name = g_quark_from_static_string ("State");
  properties[1].type = G_TYPE_UINT;
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE, &interface);

  /**
   * EmpSvcChannelInterfaceTube::tube-channel-state-changed:
   * @arg_state: guint  (FIXME, generate documentation)
   *
   * The TubeChannelStateChanged D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_interface_tube_signals[SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged] =
  g_signal_new ("tube-channel-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (emp_svc_channel_interface_tube_get_type (),
      &_emp_svc_channel_interface_tube_object_info);
}
static void
emp_svc_channel_interface_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_interface_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_interface_tube_methods[] = {
};

static const DBusGObjectInfo _emp_svc_channel_interface_tube_object_info = {
  0,
  _emp_svc_channel_interface_tube_methods,
  0,
"\0",
"org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT\0TubeChannelStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_channel_type_dbus_tube_object_info;

struct _EmpSvcChannelTypeDBusTubeClass {
    GTypeInterface parent_class;
    emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl offer_d_bus_tube;
    emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl accept_d_bus_tube;
};

enum {
    SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged,
    N_CHANNEL_TYPE_DBUS_TUBE_SIGNALS
};
static guint channel_type_dbus_tube_signals[N_CHANNEL_TYPE_DBUS_TUBE_SIGNALS] = {0};

static void emp_svc_channel_type_dbus_tube_base_init (gpointer klass);

GType
emp_svc_channel_type_dbus_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelTypeDBusTubeClass),
        emp_svc_channel_type_dbus_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelTypeDBusTube", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl:
 * @self: The object implementing this interface
 * @in_parameters: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * OfferDBusTube on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
static void
emp_svc_channel_type_dbus_tube_offer_d_bus_tube (EmpSvcChannelTypeDBusTube *self,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl = (EMP_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS (self)->offer_d_bus_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_parameters,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_type_dbus_tube_implement_offer_d_bus_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the OfferDBusTube D-Bus method
 *
 * Register an implementation for the OfferDBusTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_type_dbus_tube_implement_offer_d_bus_tube (EmpSvcChannelTypeDBusTubeClass *klass, emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl)
{
  klass->offer_d_bus_tube = impl;
}

/**
 * emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AcceptDBusTube on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
static void
emp_svc_channel_type_dbus_tube_accept_d_bus_tube (EmpSvcChannelTypeDBusTube *self,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl = (EMP_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS (self)->accept_d_bus_tube);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_type_dbus_tube_implement_accept_d_bus_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcceptDBusTube D-Bus method
 *
 * Register an implementation for the AcceptDBusTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_type_dbus_tube_implement_accept_d_bus_tube (EmpSvcChannelTypeDBusTubeClass *klass, emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl)
{
  klass->accept_d_bus_tube = impl;
}

/**
 * emp_svc_channel_type_dbus_tube_emit_d_bus_names_changed:
 * @instance: The object implementing this interface
 * @arg_added: GHashTable * (FIXME, generate documentation)
 * @arg_removed: const GArray * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * DBusNamesChanged signal on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
void
emp_svc_channel_type_dbus_tube_emit_d_bus_names_changed (gpointer instance,
    GHashTable *arg_added,
    const GArray *arg_removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE));
  g_signal_emit (instance,
      channel_type_dbus_tube_signals[SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged],
      0,
      arg_added,
      arg_removed);
}

static inline void
emp_svc_channel_type_dbus_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* ServiceName */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{us}", 0, NULL, NULL }, /* DBusNames */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT");
  properties[0].name = g_quark_from_static_string ("ServiceName");
  properties[0].type = G_TYPE_STRING;
  properties[1].name = g_quark_from_static_string ("DBusNames");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_STRING));
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, &interface);

  /**
   * EmpSvcChannelTypeDBusTube::d-bus-names-changed:
   * @arg_added: GHashTable * (FIXME, generate documentation)
   * @arg_removed: const GArray * (FIXME, generate documentation)
   *
   * The DBusNamesChanged D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_type_dbus_tube_signals[SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged] =
  g_signal_new ("d-bus-names-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_STRING)),
      DBUS_TYPE_G_UINT_ARRAY);

  dbus_g_object_type_install_info (emp_svc_channel_type_dbus_tube_get_type (),
      &_emp_svc_channel_type_dbus_tube_object_info);
}
static void
emp_svc_channel_type_dbus_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_type_dbus_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_type_dbus_tube_methods[] = {
  { (GCallback) emp_svc_channel_type_dbus_tube_offer_d_bus_tube, _emp_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) emp_svc_channel_type_dbus_tube_accept_d_bus_tube, g_cclosure_marshal_VOID__POINTER, 106 },
};

static const DBusGObjectInfo _emp_svc_channel_type_dbus_tube_object_info = {
  0,
  _emp_svc_channel_type_dbus_tube_methods,
  2,
"org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0OfferDBusTube\0A\0parameters\0I\0a{sv}\0address\0O\0F\0N\0s\0\0org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0AcceptDBusTube\0A\0address\0O\0F\0N\0s\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0DBusNamesChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_channel_type_stream_tube_object_info;

struct _EmpSvcChannelTypeStreamTubeClass {
    GTypeInterface parent_class;
    emp_svc_channel_type_stream_tube_offer_impl offer;
    emp_svc_channel_type_stream_tube_accept_impl accept;
};

enum {
    SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewRemoteConnection,
    SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewLocalConnection,
    SIGNAL_CHANNEL_TYPE_STREAM_TUBE_ConnectionClosed,
    N_CHANNEL_TYPE_STREAM_TUBE_SIGNALS
};
static guint channel_type_stream_tube_signals[N_CHANNEL_TYPE_STREAM_TUBE_SIGNALS] = {0};

static void emp_svc_channel_type_stream_tube_base_init (gpointer klass);

GType
emp_svc_channel_type_stream_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelTypeStreamTubeClass),
        emp_svc_channel_type_stream_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelTypeStreamTube", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_type_stream_tube_offer_impl:
 * @self: The object implementing this interface
 * @in_address_type: guint  (FIXME, generate documentation)
 * @in_address: const GValue * (FIXME, generate documentation)
 * @in_access_control: guint  (FIXME, generate documentation)
 * @in_parameters: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Offer on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
static void
emp_svc_channel_type_stream_tube_offer (EmpSvcChannelTypeStreamTube *self,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_type_stream_tube_offer_impl impl = (EMP_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS (self)->offer);

  if (impl != NULL)
    {
      (impl) (self,
        in_address_type,
        in_address,
        in_access_control,
        in_parameters,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_type_stream_tube_implement_offer:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Offer D-Bus method
 *
 * Register an implementation for the Offer method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_type_stream_tube_implement_offer (EmpSvcChannelTypeStreamTubeClass *klass, emp_svc_channel_type_stream_tube_offer_impl impl)
{
  klass->offer = impl;
}

/**
 * emp_svc_channel_type_stream_tube_accept_impl:
 * @self: The object implementing this interface
 * @in_address_type: guint  (FIXME, generate documentation)
 * @in_access_control: guint  (FIXME, generate documentation)
 * @in_access_control_param: const GValue * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Accept on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
static void
emp_svc_channel_type_stream_tube_accept (EmpSvcChannelTypeStreamTube *self,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_type_stream_tube_accept_impl impl = (EMP_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS (self)->accept);

  if (impl != NULL)
    {
      (impl) (self,
        in_address_type,
        in_access_control,
        in_access_control_param,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_type_stream_tube_implement_accept:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Accept D-Bus method
 *
 * Register an implementation for the Accept method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_type_stream_tube_implement_accept (EmpSvcChannelTypeStreamTubeClass *klass, emp_svc_channel_type_stream_tube_accept_impl impl)
{
  klass->accept = impl;
}

/**
 * emp_svc_channel_type_stream_tube_emit_new_remote_connection:
 * @instance: The object implementing this interface
 * @arg_Handle: guint  (FIXME, generate documentation)
 * @arg_Connection_Param: const GValue * (FIXME, generate documentation)
 * @arg_Connection_ID: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * NewRemoteConnection signal on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
void
emp_svc_channel_type_stream_tube_emit_new_remote_connection (gpointer instance,
    guint arg_Handle,
    const GValue *arg_Connection_Param,
    guint arg_Connection_ID)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE));
  g_signal_emit (instance,
      channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewRemoteConnection],
      0,
      arg_Handle,
      arg_Connection_Param,
      arg_Connection_ID);
}

/**
 * emp_svc_channel_type_stream_tube_emit_new_local_connection:
 * @instance: The object implementing this interface
 * @arg_Connection_ID: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * NewLocalConnection signal on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
void
emp_svc_channel_type_stream_tube_emit_new_local_connection (gpointer instance,
    guint arg_Connection_ID)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE));
  g_signal_emit (instance,
      channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewLocalConnection],
      0,
      arg_Connection_ID);
}

/**
 * emp_svc_channel_type_stream_tube_emit_connection_closed:
 * @instance: The object implementing this interface
 * @arg_Connection_ID: guint  (FIXME, generate documentation)
 * @arg_Error: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ConnectionClosed signal on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
void
emp_svc_channel_type_stream_tube_emit_connection_closed (gpointer instance,
    guint arg_Connection_ID,
    const gchar *arg_Error)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE));
  g_signal_emit (instance,
      channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_ConnectionClosed],
      0,
      arg_Connection_ID,
      arg_Error);
}

static inline void
emp_svc_channel_type_stream_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* Service */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{uau}", 0, NULL, NULL }, /* SupportedSocketTypes */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT");
  properties[0].name = g_quark_from_static_string ("Service");
  properties[0].type = G_TYPE_STRING;
  properties[1].name = g_quark_from_static_string ("SupportedSocketTypes");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, DBUS_TYPE_G_UINT_ARRAY));
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, &interface);

  /**
   * EmpSvcChannelTypeStreamTube::new-remote-connection:
   * @arg_Handle: guint  (FIXME, generate documentation)
   * @arg_Connection_Param: const GValue * (FIXME, generate documentation)
   * @arg_Connection_ID: guint  (FIXME, generate documentation)
   *
   * The NewRemoteConnection D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewRemoteConnection] =
  g_signal_new ("new-remote-connection",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__UINT_BOXED_UINT,
      G_TYPE_NONE,
      3,
      G_TYPE_UINT,
      G_TYPE_VALUE,
      G_TYPE_UINT);

  /**
   * EmpSvcChannelTypeStreamTube::new-local-connection:
   * @arg_Connection_ID: guint  (FIXME, generate documentation)
   *
   * The NewLocalConnection D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_NewLocalConnection] =
  g_signal_new ("new-local-connection",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  /**
   * EmpSvcChannelTypeStreamTube::connection-closed:
   * @arg_Connection_ID: guint  (FIXME, generate documentation)
   * @arg_Error: const gchar * (FIXME, generate documentation)
   *
   * The ConnectionClosed D-Bus signal is emitted whenever this GObject signal is.
   */
  channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_ConnectionClosed] =
  g_signal_new ("connection-closed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__UINT_STRING,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      G_TYPE_STRING);

  dbus_g_object_type_install_info (emp_svc_channel_type_stream_tube_get_type (),
      &_emp_svc_channel_type_stream_tube_object_info);
}
static void
emp_svc_channel_type_stream_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_type_stream_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_type_stream_tube_methods[] = {
  { (GCallback) emp_svc_channel_type_stream_tube_offer, _emp_ext_marshal_VOID__UINT_BOXED_UINT_BOXED_POINTER, 0 },
  { (GCallback) emp_svc_channel_type_stream_tube_accept, _emp_ext_marshal_VOID__UINT_UINT_BOXED_POINTER, 132 },
};

static const DBusGObjectInfo _emp_svc_channel_type_stream_tube_object_info = {
  0,
  _emp_svc_channel_type_stream_tube_methods,
  2,
"org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0Offer\0A\0address_type\0I\0u\0address\0I\0v\0access_control\0I\0u\0parameters\0I\0a{sv}\0\0org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0Accept\0A\0address_type\0I\0u\0access_control\0I\0u\0access_control_param\0I\0v\0address\0O\0F\0N\0v\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0NewRemoteConnection\0org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0NewLocalConnection\0org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0ConnectionClosed\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_connection_interface_location_object_info;

struct _EmpSvcConnectionInterfaceLocationClass {
    GTypeInterface parent_class;
    emp_svc_connection_interface_location_get_locations_impl get_locations;
    emp_svc_connection_interface_location_set_location_impl set_location;
};

enum {
    SIGNAL_CONNECTION_INTERFACE_LOCATION_LocationUpdated,
    N_CONNECTION_INTERFACE_LOCATION_SIGNALS
};
static guint connection_interface_location_signals[N_CONNECTION_INTERFACE_LOCATION_SIGNALS] = {0};

static void emp_svc_connection_interface_location_base_init (gpointer klass);

GType
emp_svc_connection_interface_location_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcConnectionInterfaceLocationClass),
        emp_svc_connection_interface_location_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcConnectionInterfaceLocation", &info, 0);
    }

  return type;
}

/**
 * emp_svc_connection_interface_location_get_locations_impl:
 * @self: The object implementing this interface
 * @in_Contacts: const GArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetLocations on interface org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT.
 */
static void
emp_svc_connection_interface_location_get_locations (EmpSvcConnectionInterfaceLocation *self,
    const GArray *in_Contacts,
    DBusGMethodInvocation *context)
{
  emp_svc_connection_interface_location_get_locations_impl impl = (EMP_SVC_CONNECTION_INTERFACE_LOCATION_GET_CLASS (self)->get_locations);

  if (impl != NULL)
    {
      (impl) (self,
        in_Contacts,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_connection_interface_location_implement_get_locations:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetLocations D-Bus method
 *
 * Register an implementation for the GetLocations method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_connection_interface_location_implement_get_locations (EmpSvcConnectionInterfaceLocationClass *klass, emp_svc_connection_interface_location_get_locations_impl impl)
{
  klass->get_locations = impl;
}

/**
 * emp_svc_connection_interface_location_set_location_impl:
 * @self: The object implementing this interface
 * @in_Location: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetLocation on interface org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT.
 */
static void
emp_svc_connection_interface_location_set_location (EmpSvcConnectionInterfaceLocation *self,
    GHashTable *in_Location,
    DBusGMethodInvocation *context)
{
  emp_svc_connection_interface_location_set_location_impl impl = (EMP_SVC_CONNECTION_INTERFACE_LOCATION_GET_CLASS (self)->set_location);

  if (impl != NULL)
    {
      (impl) (self,
        in_Location,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_connection_interface_location_implement_set_location:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetLocation D-Bus method
 *
 * Register an implementation for the SetLocation method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_connection_interface_location_implement_set_location (EmpSvcConnectionInterfaceLocationClass *klass, emp_svc_connection_interface_location_set_location_impl impl)
{
  klass->set_location = impl;
}

/**
 * emp_svc_connection_interface_location_emit_location_updated:
 * @instance: The object implementing this interface
 * @arg_Contact: guint  (FIXME, generate documentation)
 * @arg_Location: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * LocationUpdated signal on interface org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT.
 */
void
emp_svc_connection_interface_location_emit_location_updated (gpointer instance,
    guint arg_Contact,
    GHashTable *arg_Location)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_CONNECTION_INTERFACE_LOCATION));
  g_signal_emit (instance,
      connection_interface_location_signals[SIGNAL_CONNECTION_INTERFACE_LOCATION_LocationUpdated],
      0,
      arg_Contact,
      arg_Location);
}

static inline void
emp_svc_connection_interface_location_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "au", 0, NULL, NULL }, /* LocationAccessControlTypes */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ | TP_DBUS_PROPERTIES_MIXIN_FLAG_WRITE, "(uv)", 0, NULL, NULL }, /* LocationAccessControl */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT");
  properties[0].name = g_quark_from_static_string ("LocationAccessControlTypes");
  properties[0].type = DBUS_TYPE_G_UINT_ARRAY;
  properties[1].name = g_quark_from_static_string ("LocationAccessControl");
  properties[1].type = (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_VALUE, G_TYPE_INVALID));
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CONNECTION_INTERFACE_LOCATION, &interface);

  /**
   * EmpSvcConnectionInterfaceLocation::location-updated:
   * @arg_Contact: guint  (FIXME, generate documentation)
   * @arg_Location: GHashTable * (FIXME, generate documentation)
   *
   * The LocationUpdated D-Bus signal is emitted whenever this GObject signal is.
   */
  connection_interface_location_signals[SIGNAL_CONNECTION_INTERFACE_LOCATION_LocationUpdated] =
  g_signal_new ("location-updated",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  dbus_g_object_type_install_info (emp_svc_connection_interface_location_get_type (),
      &_emp_svc_connection_interface_location_object_info);
}
static void
emp_svc_connection_interface_location_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_connection_interface_location_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_connection_interface_location_methods[] = {
  { (GCallback) emp_svc_connection_interface_location_get_locations, _emp_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) emp_svc_connection_interface_location_set_location, _emp_ext_marshal_VOID__BOXED_POINTER, 118 },
};

static const DBusGObjectInfo _emp_svc_connection_interface_location_object_info = {
  0,
  _emp_svc_connection_interface_location_methods,
  2,
"org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT\0GetLocations\0A\0Contacts\0I\0au\0Locations\0O\0F\0N\0a{ua{sv}}\0\0org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT\0SetLocation\0A\0Location\0I\0a{sv}\0\0\0",
"org.freedesktop.Telepathy.Connection.Interface.Location.DRAFT\0LocationUpdated\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_tube_handler_object_info;

struct _EmpSvcTubeHandlerClass {
    GTypeInterface parent_class;
    emp_svc_tube_handler_handle_tube_impl handle_tube;
};

static void emp_svc_tube_handler_base_init (gpointer klass);

GType
emp_svc_tube_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcTubeHandlerClass),
        emp_svc_tube_handler_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcTubeHandler", &info, 0);
    }

  return type;
}

/**
 * emp_svc_tube_handler_handle_tube_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * HandleTube on interface org.gnome.Empathy.TubeHandler.
 */
static void
emp_svc_tube_handler_handle_tube (EmpSvcTubeHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  emp_svc_tube_handler_handle_tube_impl impl = (EMP_SVC_TUBE_HANDLER_GET_CLASS (self)->handle_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_tube_handler_implement_handle_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HandleTube D-Bus method
 *
 * Register an implementation for the HandleTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_tube_handler_implement_handle_tube (EmpSvcTubeHandlerClass *klass, emp_svc_tube_handler_handle_tube_impl impl)
{
  klass->handle_tube = impl;
}

static inline void
emp_svc_tube_handler_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.gnome.Empathy.TubeHandler");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_TUBE_HANDLER, &interface);

  dbus_g_object_type_install_info (emp_svc_tube_handler_get_type (),
      &_emp_svc_tube_handler_object_info);
}
static void
emp_svc_tube_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_tube_handler_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_tube_handler_methods[] = {
  { (GCallback) emp_svc_tube_handler_handle_tube, _emp_ext_marshal_VOID__STRING_BOXED_BOXED_UINT_UINT_POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_tube_handler_object_info = {
  0,
  _emp_svc_tube_handler_methods,
  1,
"org.gnome.Empathy.TubeHandler\0HandleTube\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"\0\0",
"\0\0",
};


